
#include <stdio.h>
#include "x.h"
#include "xt.h"
#include "xpex.h"

#define DEGRAD( _a )  ( (float)( _a ) * 3.1415926 / 180.0 )
#define RADDEG( _a )  ( (float)( _a ) * 180.0 / 3.1415926 )

extern Widget hsvColor;
extern Widget mixedColor;

extern Display    *display;
extern Window      mixed_window;
extern Window      window;
extern Window      red_window;
extern Window      green_window;
extern Window      blue_window;
extern Pixmap      pixmap;
extern Pixmap      red_pixmap;
extern Pixmap      green_pixmap;
extern Pixmap      blue_pixmap;
extern GC          gc;
extern Colormap    colormap;
extern int         depth;

PEXRenderer        rd;
PEXPipelineContext pc;
PEXStructure       sid;
XID                resource_id;
PEXOCRequestType   dest;

extern PEXRenderer           mixed_rd;
       unsigned long         mixed_rdMask;
extern PEXRendererAttributes mixed_rdVals;


void createHSVWindow( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
    int xpos = 100;
    int ypos = 600;
    XSetWindowAttributes WVals;

    unsigned long         rdMask = 0;
    PEXRendererAttributes rdVals;

    unsigned long      pcMask[3];
    PEXPCAttributes    pcVals;

    extern PEXColorApproxEntry   approxEnt;
    PEXLookupTable        colorApproxLUT;

    static PEXVertexRGB pointsWithData1[] = {
                        0.50, 0.5, 0.0,   1.0, 1.0, 1.0,
                        1.00, 0.5, 0.0,   1.0, 0.0, 0.0,
                        0.80, 1.0, 0.0,   1.0, 1.0, 0.0
                      };

    static PEXVertexRGB pointsWithData2[] = {
                        0.50, 0.5, 0.0,   1.0, 1.0, 1.0,
                        0.80, 1.0, 0.0,   1.0, 1.0, 0.0,
                        0.20, 1.0, 0.0,   0.0, 1.0, 0.0
                      };

    static PEXVertexRGB pointsWithData3[] = {
                        0.50, 0.5, 0.0,   1.0, 1.0, 1.0,
                        0.20, 1.0, 0.0,   0.0, 1.0, 0.0,
                        0.00, 0.5, 0.0,   0.0, 1.0, 1.0
                      };

    static PEXVertexRGB pointsWithData4[] = {
                        0.50, 0.5, 0.0,   1.0, 1.0, 1.0,
                        0.00, 0.5, 0.0,   0.0, 1.0, 1.0,
                        0.20, 0.0, 0.0,   0.0, 0.0, 1.0
                      };

    static PEXVertexRGB pointsWithData5[] = {
                        0.50, 0.5, 0.0,   1.0, 1.0, 1.0,
                        0.20, 0.0, 0.0,   0.0, 0.0, 1.0,
                        0.80, 0.0, 0.0,   1.0, 0.0, 1.0
                      };

    static PEXVertexRGB pointsWithData6[] = {
                        0.50, 0.5, 0.0,   1.0, 1.0, 1.0,
                        0.80, 0.0, 0.0,   1.0, 0.0, 1.0,
                        1.00, 0.5, 0.0,   1.0, 0.0, 0.0
                      };

    window = XtWindow( hsvColor );
    mixed_window = XtWindow( mixedColor );

    WVals.background_pixel = 0;
    WVals.border_pixel = 0;
    WVals.colormap = colormap;
    WVals.backing_store = WhenMapped;
    XChangeWindowAttributes( display, window,
        CWBackPixel | CWBorderPixel | CWBackingStore | CWColormap, &WVals );

    if( depth == 8 ) {
        gc = XCreateGC( display, window, 0, 0 );
        pixmap = XCreatePixmap( display, window, 200, 200, 8 );
        XSetForeground( display, gc, AllocColor( display, colormap, "black" ) );
        XFillRectangle( display, pixmap, gc, 0, 0, 200, 200 );
    }

    if( depth == 8 ) {
        int i, width = 21, height = 200, step, delta = 21; /* 20 + 1 */
        extern Widget redScroll, greenScroll, blueScroll;
        char *string;
        XPoint pnt[25];

        string = (char *) malloc(20);
        step = height / (delta-1);
        red_window = XtWindow( redScroll );
        red_pixmap = XCreatePixmap( display, red_window, width, height, depth );
        green_window = XtWindow( greenScroll );
        green_pixmap = XCreatePixmap( display,green_window,width,height,depth );
        blue_window = XtWindow( blueScroll );
        blue_pixmap = XCreatePixmap( display, blue_window, width,height,depth );

        for( i=1; i< delta; i++ ) {
            sprintf( string, "#%x0000", (delta-i) * 255 / (delta-1) );
            if( i == (delta-1) ) sprintf( string, "#0c0000" );
            XSetForeground( display, gc, AllocColor( display,colormap,string ));
            pnt[0].x = 0;        pnt[0].y = (i-1) * step;
            pnt[1].x = width;    pnt[1].y = (i-1) * step;
            pnt[2].x = width;    pnt[2].y = i * step;
            pnt[3].x = 0;        pnt[3].y = i * step;
            XFillPolygon( display,red_pixmap,gc,pnt,4,Convex,CoordModeOrigin );
        }
        for( i=1; i< delta; i++ ) {
            sprintf( string, "#00%x00", (delta-i) * 255 / (delta-1) );
            if( i == (delta-1) ) sprintf( string, "#000c00" );
            XSetForeground( display, gc, AllocColor( display,colormap,string ));
            pnt[0].x = 0;        pnt[0].y = (i-1) * step;
            pnt[1].x = width;    pnt[1].y = (i-1) * step;
            pnt[2].x = width;    pnt[2].y = i * step;
            pnt[3].x = 0;        pnt[3].y = i * step;
            XFillPolygon( display,green_pixmap,gc,pnt,4,Convex,CoordModeOrigin);
        }
        for( i=1; i< delta; i++ ) {
            sprintf( string, "#0000%x", (delta-i) * 255 / (delta-1) );
            if( i == (delta-1) ) sprintf( string, "#00000c" );
            XSetForeground( display, gc, AllocColor( display,colormap,string ));
            pnt[0].x = 0;        pnt[0].y = (i-1) * step;
            pnt[1].x = width;    pnt[1].y = (i-1) * step;
            pnt[2].x = width;    pnt[2].y = i * step;
            pnt[3].x = 0;        pnt[3].y = i * step;
            XFillPolygon( display,blue_pixmap,gc,pnt,4,Convex,CoordModeOrigin );
        }

        XtVaSetValues( redScroll, XtNbackgroundPixmap, red_pixmap, NULL );
        XtVaSetValues( greenScroll, XtNbackgroundPixmap, green_pixmap, NULL );
        XtVaSetValues( blueScroll, XtNbackgroundPixmap, blue_pixmap, NULL );
    }

    /* Create a renderer */
    rdVals.clear_image = True;
    rdMask |= PEXRAClearImage;
    rdVals.clear_z = True;
    rdMask |= PEXRAClearZ;
    rdVals.background_color.type = PEXColorTypeRGB;
    rdVals.background_color.value.rgb.red = 0.0;
    rdVals.background_color.value.rgb.green = 0.0;
    rdVals.background_color.value.rgb.blue = 0.0;
    rdMask |= PEXRABackgroundColor;

    /* Create Color Approx lookup table */
    if( depth != 8 ) {
        colorApproxLUT = PEXCreateLookupTable( display, window,
            PEXLUTColorApprox );
        PEXSetTableEntries( display, colorApproxLUT, 0, 1,
            PEXLUTColorApprox, (PEXPointer)&approxEnt );

        rdVals.color_approx_table = colorApproxLUT;
        rdMask |= PEXRAColorApproxTable;
    }

    rd = PEXCreateRenderer( display, window, rdMask, &rdVals );

    /* Create a renderer for the background */
    mixed_rdVals.clear_image = True;
    mixed_rdMask |= PEXRAClearImage;
    mixed_rdVals.background_color.type = PEXColorTypeRGB;
    mixed_rdVals.background_color.value.rgb.red = 0.0;
    mixed_rdVals.background_color.value.rgb.green = 0.0;
    mixed_rdVals.background_color.value.rgb.blue = 0.0;
    mixed_rdMask |= PEXRABackgroundColor;
    if( depth != 8 ) {
        mixed_rdVals.color_approx_table = colorApproxLUT;
        mixed_rdMask |= PEXRAColorApproxTable;
    }

    mixed_rd = PEXCreateRenderer( display, mixed_window,
        mixed_rdMask, &mixed_rdVals );

    sid = PEXCreateStructure( display );
    resource_id = (XID)sid;
    dest = PEXOCStore;

    if( depth == 8 ) {
        /* red */
        XSetForeground( display, gc, AllocColor( display,colormap,"#ff0000" ) );
        XFillArc( display, pixmap, gc, 0,0, 200,200, -1920, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ff5f5f" ) );
        XFillArc( display, pixmap, gc, 25,25, 150,150, -1920, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ff7f7f" ) );
        XFillArc( display, pixmap, gc, 50,50, 100,100, -1920, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffbfbf" ) );
        XFillArc( display, pixmap, gc, 75,75,  50, 50, -1920, 3840 );

        /* yellow */
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffff00" ) );
        XFillArc( display, pixmap, gc, 0,0, 200,200, 1920, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffff5f" ) );
        XFillArc( display, pixmap, gc, 25,25, 150,150, 1920, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffff7f" ) );
        XFillArc( display, pixmap, gc, 50,50, 100,100, 1920, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffffbf" ) );
        XFillArc( display, pixmap, gc, 75,75,  50, 50, 1920, 3840 );

        /* green */
        XSetForeground( display, gc, AllocColor( display,colormap,"#00ff00" ) );
        XFillArc( display, pixmap, gc, 0,0, 200,200, 5760, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#5fff5f" ) );
        XFillArc( display, pixmap, gc, 25,25, 150,150, 5760, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#7fff7f" ) );
        XFillArc( display, pixmap, gc, 50,50, 100,100, 5760, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#bfffbf" ) );
        XFillArc( display, pixmap, gc, 75,75,  50, 50, 5760, 3840 );

        /* cyan */
        XSetForeground( display, gc, AllocColor( display,colormap,"#00ffff" ) );
        XFillArc( display, pixmap, gc, 0,0, 200,200, 9600, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#5fffff" ) );
        XFillArc( display, pixmap, gc, 25,25, 150,150, 9600, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#7fffff" ) );
        XFillArc( display, pixmap, gc, 50,50, 100,100, 9600, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#bfffff" ) );
        XFillArc( display, pixmap, gc, 75,75,  50, 50, 9600, 3840 );

        /* blue */
        XSetForeground( display, gc, AllocColor( display,colormap,"#0000ff" ) );
        XFillArc( display, pixmap, gc, 0,0, 200,200, 13440, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#5f5fff" ) );
        XFillArc( display, pixmap, gc, 25,25, 150,150, 13440, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#7f7fff" ) );
        XFillArc( display, pixmap, gc, 50,50, 100,100, 13440, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#bfbfff" ) );
        XFillArc( display, pixmap, gc, 75,75,  50, 50, 13440, 3840 );

        /* magenta */
        XSetForeground( display, gc, AllocColor( display,colormap,"#ff00ff" ) );
        XFillArc( display, pixmap, gc, 0,0, 200,200, 17280, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ff5fff" ) );
        XFillArc( display, pixmap, gc, 25,25, 150,150, 17280, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ff7fff" ) );
        XFillArc( display, pixmap, gc, 50,50, 100,100, 17280, 3840 );
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffbfff" ) );
        XFillArc( display, pixmap, gc, 75,75,  50, 50, 17280, 3840 );

        /* white */
        XSetForeground( display, gc, AllocColor( display,colormap,"#ffffff" ) );
        XFillRectangle( display, pixmap, gc, 100-3, 100-3, 6, 7 );

        XSetForeground( display, gc, AllocColor( display, colormap, "black" ) );
        XCopyArea( display, pixmap, window, gc, 0, 0, 200, 200, 0, 0 );
    }
    else {
        PEXArrayOfVertex triStrip;
        PEXArrayOfFacetData facetData;
        unsigned int vertexAttributes;
        unsigned int facetAttributes;
        int          colorType;

        PEXSetInteriorStyle( display, resource_id, dest,
            PEXInteriorStyleSolid );
        PEXSetSurfaceInterpMethod( display, resource_id, dest,
            PEXSurfaceInterpColor );

        facetAttributes = PEXGANone;
        vertexAttributes = PEXGAColor;
        colorType = PEXColorTypeRGB;

        facetData.rgb_normal = (PEXColorRGBNormal *)NULL;

        triStrip.rgb = pointsWithData1;
        PEXTriangleStrip( display, resource_id, dest,
            facetAttributes, vertexAttributes, colorType,
            facetData, 3, triStrip );
        triStrip.rgb = pointsWithData2;
        PEXTriangleStrip( display, resource_id, dest,
            facetAttributes, vertexAttributes, colorType,
            facetData, 3, triStrip );
        triStrip.rgb = pointsWithData3;
        PEXTriangleStrip( display, resource_id, dest,
            facetAttributes, vertexAttributes, colorType,
            facetData, 3, triStrip );
        triStrip.rgb = pointsWithData4;
        PEXTriangleStrip( display, resource_id, dest,
            facetAttributes, vertexAttributes, colorType,
            facetData, 3, triStrip );
        triStrip.rgb = pointsWithData5;
        PEXTriangleStrip( display, resource_id, dest,
            facetAttributes, vertexAttributes, colorType,
            facetData, 3, triStrip );
        triStrip.rgb = pointsWithData6;
        PEXTriangleStrip( display, resource_id, dest,
            facetAttributes, vertexAttributes, colorType,
            facetData, 3, triStrip );
#if 0
        PEXListOfVertex pointList[6];

        pointList[0].count = 3;    pointList[0].vertices.rgb = pointsWithData1;
        pointList[1].count = 3;    pointList[1].vertices.rgb = pointsWithData2;
        pointList[2].count = 3;    pointList[2].vertices.rgb = pointsWithData3;
        pointList[3].count = 3;    pointList[3].vertices.rgb = pointsWithData4;
        pointList[4].count = 3;    pointList[4].vertices.rgb = pointsWithData5;
        pointList[5].count = 3;    pointList[5].vertices.rgb = pointsWithData6;

        PEXFillAreaSetWithData( display, resource_id, dest,
                                PEXShapeConvex, False, PEXContourDisjoint,
                                facetAttributes, vertexAttributes, colorType,
                                6, &facetData, pointList );
#endif
        PEXLabel( display, resource_id, dest, 1 );
        /* dummy element in structure */
        PEXApplicationData( display, resource_id, dest, 0, (char*)NULL );

        PEXRenderNetwork( display, window, rd, sid );
        XFlush( display );
    }
}
