
/*
 * Taken from
 * RasMol2 Molecular Graphics
 * Roger Sayle, February 1994
 * Version 2.3
 *
 * Modified for the purpose of this program
 */

#include <stdio.h>
#include "x.h"

static void WritePPMWord( i, fp )
int i;
FILE *fp;
{
    if( i>99 ) {
        fputc( ( i/100 )+'0', fp ); i %= 100;
        fputc( ( i/10 ) +'0', fp ); i %= 10;
    }
    else if( i>9 ) {
        fputc( ( i/10 )+'0', fp );  i %= 10;
    }
    putc( i+'0', fp );
}


int WritePPMFile( name, raw, FBuffer, bytes_per_line, XRange, YRange, depth,
    Lut, RLut, GLut, BLut, ULut )
char * name, * FBuffer;
int raw, bytes_per_line;
unsigned int XRange, YRange;
int depth;
char Lut[1024], RLut[256], GLut[256], BLut[256], ULut[256];
{
    char LutInv[256];
    register int i, c;
    register int x, y;
    FILE *fp;

    if( !( fp = fopen( name, "w" ) ) ) {
        fprintf( stderr, "Could not open ppm file\n" );
        exit( 1 );
    }
    fputc( 'P', fp ); fputc( ( raw?'6':'3' ), fp );
    fprintf( fp, " %d %d 255\n", XRange, YRange );

    if( depth == 8 ) {

        register unsigned char *ptr = FBuffer;

        for( i=0; i<256; i++ )
            if( ULut[i] )
                LutInv[Lut[i]] = i;

        if( !raw ) {
            c = 0;
            for( y=YRange-1; y>=0; y-- ) {
                for( x=0; x<XRange; x++ ) {
                    i = *ptr++; c++;
                    WritePPMWord( (int)RLut[LutInv[i]], fp );  fputc( ' ', fp );
                    WritePPMWord( (int)GLut[LutInv[i]], fp );  fputc( ' ', fp );
                    WritePPMWord( (int)BLut[LutInv[i]], fp );
                    if( c==5 ) {
                        c=0;
                        fputc( '\n', fp );
                    }
                    else
                        fputc( ' ', fp );
                }
                for( x=XRange; x<bytes_per_line; x++ )
                    ptr++;
            }
        }
        else {
            for( y=YRange-1; y>=0; y-- ) {
                for( x=0; x<XRange; x++ ) {
                    i = *ptr++;
                    fputc( (int)RLut[LutInv[i]], fp );
                    fputc( (int)GLut[LutInv[i]], fp );
                    fputc( (int)BLut[LutInv[i]], fp );
                }
                for( x=XRange; x<bytes_per_line; x++ )
                    ptr++;
            }
        }
    }
    else {

        register Pixel *ptr = (Pixel *)FBuffer;

        if( !raw ) {
            c = 0;
            for( y=YRange-1; y>=0; y-- ) {
                for( x=0; x<XRange; x++ ) {
                    i = *ptr++; c++;
                    WritePPMWord( (int)(((i)>>16)&0xff), fp );
                    fputc( ' ', fp );
                    WritePPMWord( (int)(((i)>>8)&0xff), fp );
                    fputc( ' ', fp );
                    WritePPMWord( (int)( (i)&0xff), fp );
                    if( c==5 ) {
                        c=0;
                        fputc( '\n', fp );
                    }
                    else
                        fputc( ' ', fp );
                }
                for( x=XRange; x<bytes_per_line / 4; x++ )
                    ptr++;
            }
        }
        else {
            for( y=YRange-1; y>=0; y-- ) {
                for( x=0; x<XRange; x++ ) {
                    i = *ptr++;
                    fputc( (int)(((i)>>16)&0xff), fp );
                    fputc( (int)(((i)>>8)&0xff), fp );
                    fputc( (int)( (i)&0xff), fp );
                }
                for( x=XRange; x<bytes_per_line / 4; x++ )
                    ptr++;
            }
        }
    }

    fclose( fp );
    return( True );
}
